/// <reference types="node" />
import CleanCSS from "clean-css";
import type { LoaderContext } from "webpack";
declare type CleanCSSOptions = Omit<
  Exclude<ConstructorParameters<typeof CleanCSS>[0], undefined>,
  "returnPromise"
>;
interface LoaderOptions extends CleanCSSOptions {
  skipWarn?: boolean;
  disable?: boolean;
}
interface SourceMap {
  version: number;
  sources: string[];
  mappings: string;
  file?: string;
  sourceRoot?: string;
  sourcesContent?: string[];
  names?: string[];
}
interface AdditionalData {
  [index: string]: any;
  webpackAST: object;
}
declare function cleanCssLoader(
  this: LoaderContext<LoaderOptions>,
  content: string | Buffer,
  prevSourceMap?: string | SourceMap,
  additionalData?: AdditionalData
): void;
export = cleanCssLoader;
